#include <string>
#include <windows.h>
#include "mmsystem.h"

#pragma comment(lib, "winmm.lib")

using namespace std;

#define STRING_SIZE 10000000
#define COUNT       100
#define SUB_STR     "ABCDE"

size_t find_string                (const string s)  { return s.find(SUB_STR);  }
size_t find_const_string          (const string s)  { return s.find(SUB_STR);  }
size_t find_pointer_string        (string* s)       { return s->find(SUB_STR); }
size_t find_const_pointer_string  (const string* s) { return s->find(SUB_STR); }
size_t find_reference_string      (string& s)       { return s.find(SUB_STR);  }
size_t find_const_reference_string(const string& s) { return s.find(SUB_STR);  }

int main()
{
  string s;
  DWORD begTick, endTick;
  int i;

  //
  // make string
  //
  while (true)
  {
    for (int i = 0; i < STRING_SIZE; i++)
      s += rand() % 256;
    // make sure that stirng s has no SUB_STR
    if (s.find(SUB_STR) == string::npos) break;
  }

  //
  // find_string
  //
  begTick = timeGetTime();
  for(i = 0; i < COUNT; i++)
    find_string(s);
  endTick = timeGetTime();
  printf("find_string                 elapsed %u msec\n", endTick - begTick);

  //
  // find_const_string
  //
  begTick = timeGetTime();
  for(i = 0; i < COUNT; i++)
    find_const_string(s);
  endTick = timeGetTime();
  printf("find_const_string           elapsed %u msec\n", endTick - begTick);

  //
  // find_pointer_string
  //
  begTick = timeGetTime();
  for(i = 0; i < COUNT; i++)
    find_pointer_string(&s);
  endTick = timeGetTime();
  printf("find_pointer_string         elapsed %u msec\n", endTick - begTick);

  //
  // find_const_pointer_string
  //
  begTick = timeGetTime();
  for(i = 0; i < COUNT; i++)
    find_const_pointer_string(&s);
  endTick = timeGetTime();
  printf("find_const_pointer_string   elapsed %u msec\n", endTick - begTick);

  //
  // find_reference_string
  //
  begTick = timeGetTime();
  for(i = 0; i < COUNT; i++)
    find_reference_string(s);
  endTick = timeGetTime();
  printf("find_reference_string       elapsed %u msec\n", endTick - begTick);

  //
  // find_const_reference_string
  //
  begTick = timeGetTime();
  for(i = 0; i < COUNT; i++)
    find_const_reference_string(s);
  endTick = timeGetTime();
  printf("find_const_reference_string elapsed %u msec\n", endTick - begTick);

  return 0;
}